#ifndef RN_CK
#define RN_CK

namespace MyLib {

		double sqr( double x );


		//
		//    Wichmann/Hill generator... = 1.0e12
		//
		class WHrn {
		public:
			unsigned __int32 x;
			unsigned __int32 y;
			unsigned __int32 z;
			double u;

			int c, s;

			WHrn(): x(11111), y(22222), z(33333), c(0), s(0) {}
			virtual ~WHrn(){}

			WHrn(unsigned __int32 ix, unsigned __int32 iy, unsigned __int32 iz):
				x(ix), y(iy), z(iz), c(0), s(0) {}

			WHrn( int vc, int vs );
			WHrn( int vc, int vs, unsigned __int32 ix, unsigned __int32 iy, unsigned __int32 iz);

			void uni0();
			double uni();		//     0 < uni() < 1
		};
		//
		//		K
		//
		class NormalRN: public WHrn {
		public:
			NormalRN(){}
			virtual ~NormalRN(){}

			NormalRN(unsigned __int32 ix, unsigned __int32 iy, unsigned __int32 iz): WHrn(ix, iy, iz) {}		

			//
			//		WK
			//
			double NormalRN::normal();
			//
			//		 mA@W΍ s ̐K
			//
			double NormalRN::normalMS(double m, double s);

			//
			//		ƗȕWK n1  n2 ̑
			//
			void  NormalRN::normalPair( double & n1, double & n2 );

		};

}

#endif
